pro Getlevel2data,varname,file,SDSXSize,SDSYSIZE,tile,tilesize,rescale,tilelineindex,imagedata,scaleNo=scaleNo, offsetNo=offsetNo, fillNo=fillNo

localchannel=0

if rescale gt 0 then begin
   ;tileLineIndex is the line number in the file at the beginning of the tile
 
   if tileLineIndex+tilesize+1 gt SDSYSize then begin
     tilesize=SDSYSize-tileLineIndex-1
   endif

   tilevector=[SDSXSize,tilesize+1]
   startvector=[0,tileLineIndex]
endif

;Read SDS data
fileId = HDF_SD_START(file, /READ)

index = HDF_SD_NAMETOINDEX(fileId, varname)
sdsid = HDF_SD_SELECT(fileId, index)

if varname eq 'Effective_Radius_Difference' then begin
  startvector=[1,0,tileLineIndex]
  tilevector=[1,SDSXSize,tilesize+1]
endif

if rescale gt 0 then begin
   HDF_SD_GETDATA, sdsid, imagedata,$
                          count=tilevector,$
                          start=startvector
endif else begin
   HDF_SD_GETDATA, sdsid, imagedata,$
                          stride=[abs(rescale),abs(rescale)],$
                          start=[0,0],$
                          count=[SDSXSize,SDSYSize]
endelse

if varname eq 'Effective_Radius_Difference' then begin
 imagedata=reform(imagedata)
 startvector=[0,tileLineIndex]
 tilevector=[SDSXSize,tilesize+1]
 index = HDF_SD_NAMETOINDEX(fileId, 'Effective_Particle_Radius')
 sdsid2 = HDF_SD_SELECT(fileId, index)

 HDF_SD_GETDATA, sdsid2, imagedata2,$
        count=tilevector,$
        start=startvector
 scale_sds_name='scale_factor'
 scaleId = HDF_SD_ATTRFIND(sdsid2,scale_sds_name)
 HDF_SD_ATTRINFO, sdsid2, scaleId, DATA=scale_factor
 imagedata2 = imagedata2 * scale_factor[0]

endif

;find the names of the calibration parameters
scale_sds_name='scale_factor'
offset_sds_name='add_offset'
validrange_sds_name= 'valid_range'
fillvalue_sds_name= '_FillValue'

;get the calibration parameters
IF NOT Keyword_Set(scaleNo) THEN BEGIN
   scaleId = HDF_SD_ATTRFIND(sdsid,scale_sds_name)
   IF scaleId NE -1 THEN BEGIN
      HDF_SD_ATTRINFO, sdsid, scaleId, DATA=scale_factor
   ENDIF
ENDIF

IF NOT Keyword_Set(offsetNo) THEN BEGIN
   offsetId = HDF_SD_ATTRFIND(sdsid,offset_sds_name)
   IF offsetId NE -1 THEN BEGIN
      HDF_SD_ATTRINFO, sdsid, offsetId, DATA=offset
   ENDIF
ENDIF

IF NOT Keyword_Set(validrangeNo) THEN BEGIN
   validrangeId = HDF_SD_ATTRFIND(sdsid,validrange_sds_name)
   IF validrangeId NE -1 THEN BEGIN
      HDF_SD_ATTRINFO, sdsid, validrangeId, DATA=validrange
   ENDIF
ENDIF

IF NOT Keyword_Set(fillNo) THEN BEGIN
   fillId = HDF_SD_ATTRFIND(sdsid,fillvalue_sds_name)
   IF fillId NE -1 THEN BEGIN
      HDF_SD_ATTRINFO, sdsid, fillId, DATA=fillValue
   ENDIF
   fillvalue=fillvalue[0]
ENDIF

HDF_SD_ENDACCESS, sdsid
HDF_SD_END, fileId
imagedata = scale_factor[localchannel] * (imagedata-offset[localchannel])
allvalidrange=scale_factor[localchannel] * (validrange-offset[localchannel])
if varname eq 'Effective_Radius_Difference' then begin
  imagedata=imagedata+imagedata2
endif
; resize data array
;dummy=size(imagedata)
;if dummy[1] lt 250 then begin
;   SDSXSize=SDSXSize*10
;   SDSYSize=SDSYSize*10
;   imagedata=congrid(imagedata,SDSXSize,SDSYSize,/interp)
;endif


 
end
