pro OutputImageFile,image,format,xparameter,minimap,mapsize,notation,outfilename
xoffset = xparameter(0)
yoffset = xparameter(1)
xsize = xparameter(2)
ysize = xparameter(3)

if notation le 1 and mapsize gt 0 then begin
 for ii=0,mapsize-1 do begin
   for jj=0,mapsize-1 do begin
     for ch=0,2 do begin
       if minimap[ii,jj,ch] gt 0 then image[ii,jj,ch]=minimap[ii,jj,ch]
     endfor
   endfor
 endfor
endif

if format eq 2 then begin
   tv, image,xoffset,yoffset,xsize = xsize,  $
           ysize = ysize, $
           true=3
   if notation le 1 then begin
     map_continents,/hires,color=255
     map_grid,/box_axes,color=0,font=3,charsize=.8
     map_grid,/labels,color=255,font=3
   endif
 
   device,/close
   set_plot,'x'
endif

if format eq 1 or format eq 3 then begin
   map_continents,/hires,color=255
   map_grid,/box_axes,color=255,font=3,charsize=.8
   map_grid,/labels,color=255,font=3
   background=tvrd()
   background_pixels=where(background gt 0,backcount)

   newimage=bytarr(!d.x_size,!d.y_size,3)

   dummy=size(image)
   xsize = dummy(1)
   ysize = dummy(2)
   if dummy[0] eq 2 then begin
    for i=0,2 do newimage[xoffset:xoffset+xsize-1,yoffset:yoffset+ysize-1,i]=image
   endif else begin
    newimage[xoffset:xoffset+xsize-1,yoffset:yoffset+ysize-1,*]=image
   endelse

   if backcount gt 0 and notation le 1 then begin
     newimage_0=newimage[*,*,0]
     newimage_1=newimage[*,*,1]
     newimage_2=newimage[*,*,2]

     newimage_0[background_pixels]=background[background_pixels]
     newimage_1[background_pixels]=background[background_pixels]
     newimage_2[background_pixels]=background[background_pixels]

     newimage[*,*,0]=newimage_0
     newimage[*,*,1]=newimage_1
     newimage[*,*,2]=newimage_2
   endif

   arraysize=size(newimage)
   tiff_out=bytarr(arraysize(3),arraysize(1),arraysize(2))
   tiff_out[0,*,*]=newimage[*,*,0]
   tiff_out[1,*,*]=newimage[*,*,1]
   tiff_out[2,*,*]=newimage[*,*,2]
   tiff_out=reverse(tiff_out,3)
 
   print,outfilename
 
   if format eq 1 then write_tiff,outfilename,tiff_out,1
   if format eq 3 then write_jpeg,outfilename,tiff_out,quality=90,true=1,/order
endif
end
