function CONGRID, arr, x, y, z, INTERP=int, MINUS_ONE=m1, CUBIC = cubic

    ON_ERROR, 2		;Return to caller if error
    s = Size(arr)

    if ((s[0] eq 0) or (s[0] gt 3)) then $
      Message, 'Array must have 1, 2, or 3 dimensions.'
    
    ;;  Supply defaults = no interpolate, and no minus_one.
    if (N_ELEMENTS(int) le 0) then int = 0 else int = KEYWORD_SET(int)
    if (N_ELEMENTS(m1) le 0) then m1 = 0 else m1 = KEYWORD_SET(m1)
    if (N_ELEMENTS(cubic) eq 0) then cubic = 0
    if (cubic ne 0) then int = 1	;Cubic implies interpolate
	

    if (int) then begin
         srx = float(s[1] - m1) / (x-m1) * findgen(x)
         sry = float(s[2] - m1) / (y-m1) * findgen(y)
         return, INTERPOLATE(arr, srx, sry, /GRID, CUBIC=cubic)
    endif else $
         return, POLY_2D(arr, $
           [[0,0],[(s[1]-m1)/float(x-m1),0]], $ ;Use poly_2d
           [[0,(s[2]-m1)/float(y-m1)],[0,0]],int,x,y)
            
    return, arr_r
end
